# -*- coding: UTF-8 -*-
from horus import backend
from os.path import isdir, isfile
from os import system
from creole.client import CreoleClient
from time import sleep
import ftplib

dico = CreoleClient().get_creole()
smb = dico['container_ip_fichier']
smb_workgroup = dico['smb_workgroup']
mount_cmd = 'mount -t cifs'
password = 'Eole12345!'

def test_create_group():
    assert backend.add_group('tgroupe')
    assert backend.add_group('tgroupe2')

def test_create_share():
    assert backend.add_share('tgroupe2', 'tgroupe2')

def test_create_user():
    assert backend.add_user('tuser', 'tgroupe')
    sleep(1)
    assert 'DomainUsers' in backend.get_user_groups('tuser')
    assert backend.mod_password('tuser', password)

def test_inscription():
    assert backend.inscription('tuser', 'tgroupe2')
    assert isdir('/home/tuser/.ftp/tgroupe2')

def test_smb_perso():
    system('mkdir -p /tmp/home')
    assert system('%s //%s/tuser /tmp/home -o username=tuser,password=%s,domain=%s' % (mount_cmd, smb, password, smb_workgroup)) == 0
    system('touch /tmp/home/fichier.txt')
    assert isfile('/tmp/home/fichier.txt')
    system('rm -f /tmp/home/fichier.txt')
    assert not isfile('/tmp/home/fichier.txt')
    # test antivirus temps réel
    if dico.get('smb_vscan', 'non') == 'oui':
        system("""echo 'X5O!P%@AP[4\PZX54(P^)7CC)7}$EICAR-STANDARD-ANTIVIRUS-TEST-FILE!$H+H*' > /tmp/home/virus.txt""")
        sleep(2)
        assert not isfile('/tmp/home/virus.txt')

def test_umount():
    # fonction dédiée en cas de plantage de la prédédente
    system('rm -f /tmp/home/virus.txt')
    system('umount /tmp/home/')

def test_smb_share():
    system('mkdir -p /tmp/tgroupe2')
    assert system('%s //%s/tgroupe2 /tmp/tgroupe2 -o username=tuser,password=%s,domain=%s' % (mount_cmd, smb, password, smb_workgroup)) == 0
    system('touch /tmp/tgroupe2/fichier.txt')
    assert isfile('/tmp/tgroupe2/fichier.txt')
    system('rm -f /tmp/tgroupe2/fichier.txt')
    assert not isfile('/tmp/tgroupe2/fichier.txt')
    system('umount /tmp/tgroupe2')

def test_profils():
    # profil à la création
    assert backend.get_attr('tuser', 'sambaProfilePath') == []
    # modification
    backend.mod_user('tuser', profile="obligatoire")
    assert backend.get_attr('tuser', 'sambaProfilePath') == ["\\\\%(smb_netbios_name)s\\netlogon\\profil" % dico]

def test_quotas():
    # quotas à la création
    assert backend.get_quota('tuser') == 0
    # modification de quotas
    backend.set_quota('tuser', 50)
    assert backend.get_quota('tuser') == 50

def test_ftp_user():
    if dico['activer_proftpd'] == 'oui':
        session = ftplib.FTP(smb, 'tuser', password)
        session.quit()

def test_del_user():
    system('touch /home/tuser.txt')
    system('chown tuser /home/tuser.txt')
    uid = backend.get_attr('tuser', 'uidNumber')[0]
    assert backend.get_quota(uid) == 50
    assert backend.del_user('tuser', remove_data=True)
    assert backend.get_quota(uid) == 0
    assert not isdir('/home/tuser')
    system('rm -f /home/tuser.txt')

def test_del_group():
    assert backend.del_group('tgroupe')
    assert backend.del_group('tgroupe2')
